//select textarea
let userInput = document.getElementById('user-input');
//select btn
let form = document.getElementById('scramble-form');
//select result container
let resultContainer = document.getElementById('result-container');

let wordCountContainer = document.getElementById('word-count');

let letterCountContainer = document.getElementById('letter-count');

function getUserInput() {
    //return value of userInput
    return userInput.value;
}

function textToWordArray(text) {
    //return array of words
    return text.split(' ');
}

function arrayToText(array) {
    return array.join(' ');
}

function getRandomNumber(max) {
    //return random number between 0 and max (including 0 and excluding max)
    return Math.floor(Math.random() * max);
}

function scrambleArray(oldArray) {
    let newArray = [];

    while (oldArray.length > 0) {
        let randomIndex = getRandomNumber(oldArray.length);
        let randomValue = oldArray.splice(randomIndex, 1);
        newArray.push(randomValue[0]);
    }

    return newArray;
}

function getWordCount(array) {
    wordCountContainer.innerHTML = array.length;
}

function getLetterCount(text) {
    letterCountContainer.innerHTML = text.length;
}

function scrambleText(text) {
    let array = textToWordArray(text);
    getWordCount(array);
    let scrambled = scrambleArray(array);
    return arrayToText(scrambled);
}

function onClickScramble(event) {
    event.preventDefault();

    let text = getUserInput();
    let scrambledText = scrambleText(text);
    getLetterCount(text);
    resultContainer.innerHTML = scrambledText;
}

//add click event listener to submitBtn
form.addEventListener('submit', onClickScramble);
userInput.addEventListener('input', onClickScramble);
