const inputContainer = document.getElementById('input-container');
const addInputBtn = document.getElementById('add-input-btn');
const inputCountContainer = document.getElementById('number-count-container');
const sumResultContainer = document.getElementById('sum-result-container');
const productResultContainer = document.getElementById(
    'product-result-container'
);

function updateInputCount() {
    inputCountContainer.innerHTML = inputContainer.children.length;
}

function calculateSum() {
    let result = 0;
    const inputs = inputContainer.querySelectorAll('input');
    for (let i = 0; i < inputs.length; i++) {
        result += parseInt(inputs[i].value);
    }
    return result;
}

function calculateProduct() {
    let result = 1;
    const inputs = inputContainer.querySelectorAll('input');
    for (let i = 0; i < inputs.length; i++) {
        result *= parseInt(inputs[i].value);
    }
    return result;
}

function updateResults() {
    sumResultContainer.innerHTML = calculateSum();
    productResultContainer.innerHTML = calculateProduct();
}

function hideOrShowDeleteBtns() {
    if (inputContainer.children.length > 2) {
        inputContainer.classList.remove('hide-delete-btns');
    } else {
        inputContainer.classList.add('hide-delete-btns');
    }
}

function addInput(event) {
    const newInput = document.createElement('div');
    newInput.classList.add('field', 'has-addons', 'number-input-group');
    newInput.innerHTML = `
        <div class="control">
            <input
                class="input number-input"
                type="number"
                step="1"
                value="0"
            />
        </div>
        <div class="control">
            <a class="button is-danger delete-number-input">X</a>
        </div>
    `;
    inputContainer.appendChild(newInput);
    updateInputCount();
    updateResults();
    hideOrShowDeleteBtns();
}

function removeInput(event) {
    if (
        event.target.matches('.delete-number-input') &&
        inputContainer.children.length > 2
    ) {
        event.target.closest('.field').remove();
        updateInputCount();
        hideOrShowDeleteBtns();
        updateResults();
    }
}
inputContainer.addEventListener('click', removeInput);
inputContainer.addEventListener('input', updateResults);
addInputBtn.addEventListener('click', addInput);
