let array = [4, 8, 12, 16];

//foreach
array.forEach(function(item) {
    // console.log(item);
});

Array.prototype.selfForEach = function(callback) {
    for (let i = 0; i < this.length; i++) {
        callback(this[i], i, this);
    }
};

function forEachCallback(item, index, originalArray) {}

array.selfForEach(forEachCallback);

Array.prototype.selfMap = function(callback) {
    let mappedArray = [];

    for (let i = 0; i < this.length; i++) {
        mappedArray.push(callback(this[i], i, this));
    }

    return mappedArray;
};

function mapCallback(item, index, originalArray) {
    if (index !== 4) {
        return item * 2;
    }
    return item;
}

let newArray = array.map(mapCallback);

Array.prototype.selfFilter = function(callback) {
    let filteredArray = [];

    for (let i = 0; i < this.length; i++) {
        if (callback(this[i], i, this)) {
            filteredArray.push(this[i]);
        }
    }

    return filteredArray;
};

let otherArray = [1, 2, 3, 4, 5];

let filteredArray = otherArray.selfFilter(function(item, index, originalArray) {
    return item > 2;
});

// oef 1
// [1,2,3,4,5,6] => [2,4,6]

let ex1 = [1, 2, 3, 4, 5, 6].filter(function(item) {
    return item % 2 === 0;
});

// console.log(ex1);

// oef 2
// ['a', 'b', 'c'] => ['A', 'B', 'C']

let ex2 = ['a', 'b', 'c'].map(function(item) {
    return item.toUpperCase();
});

// console.log(ex2);

// oef 3
// [1,2,3] => ['1','2','3']

let ex3 = [1, 2, 3].map(function(item) {
    return item.toString();
});

// console.log(ex3);

// oef 4
// [
//     { name: 'Tom', age: 5 },
//     { name: 'Ben', age: 6 },
//     { name: 'Charly', age: 2 },
// ];
// => ['Tom', 'Ben', 'Charly']

let ex4 = [
    { name: 'Tom', age: 5 },
    { name: 'Ben', age: 6 },
    { name: 'Charly', age: 2 },
].map(function(item) {
    return item.name;
});

// console.log(ex4);

// oef 5
// enkel ouder dan 4
// [
//     { name: 'Tom', age: 5 },
//     { name: 'Ben', age: 6 },
//     { name: 'Charly', age: 2 },
// ];
// =>
//[
//     { name: 'Tom', age: 5 },
//     { name: 'Ben', age: 6 },
// ];

let ex5 = [
    { name: 'Tom', age: 5 },
    { name: 'Ben', age: 6 },
    { name: 'Charly', age: 2 },
].filter(function(item) {
    return item.age > 4;
});

// console.log(ex5);

// oef 6
// combinatie van vorige 2
// [
//     { name: 'Tom', age: 5 },
//     { name: 'Ben', age: 6 },
//     { name: 'Charly', age: 2 },
// ];
// =>
//[ 'Tom', 'Ben' ];

let ex6 = [
    { name: 'Tom', age: 5 },
    { name: 'Ben', age: 6 },
    { name: 'Charly', age: 2 },
]
    .filter(function(item) {
        return item.age > 4;
    })
    .map(function(item) {
        return item.name;
    });

// console.log(ex6);

//oef 7
// voor plus 18 add naam + 'can go to The Matrix'
// min 18 add naam + 'is under age!!'
//[
//     {
//         name: "Angelina Jolie",
//         age: 80
//     },
//     {
//         name: "Eric Jones",
//         age: 2
//     },
//     {
//         name: "Paris Hilton",
//         age: 5
//     },
//     {
//         name: "Kayne West",
//         age: 16
//     },
//     {
//         name: "Bob Ziroll",
//         age: 100
//     }
// ];
// =>
// [
//  "Angelina Jolie can go to The Matrix",
//  "Eric Jones is under age!!",
//  "Paris Hilton is under age!!",
//  "Kayne West is under age!!",
//  "Bob Ziroll can go to The Matrix"
// ]

let ex7 = [
    {
        name: 'Angelina Jolie',
        age: 80,
    },
    {
        name: 'Eric Jones',
        age: 2,
    },
    {
        name: 'Paris Hilton',
        age: 5,
    },
    {
        name: 'Kayne West',
        age: 16,
    },
    {
        name: 'Bob Ziroll',
        age: 100,
    },
].map(function(item) {
    if (item.age >= 18) {
        return item.name + ' can go to The Matrix';
    }

    return item.name + ' is under age!!';
});

// console.log(ex7);

Array.prototype.selfReduce = function(callback, initialValue) {
    let result = initialValue;

    for (let i = 0; i < this.length; i++) {
        result = callback(result, this[i], index, this);
    }

    return result;
};

let reduceArray = [1, 2, 3, 4];

let sumOfArray = reduceArray.reduce(function(result, item) {
    return result + item;
}, 0);

console.log(sumOfArray);

let ex8 = ['ik', 'ben', 'tof'].reduce(function(result, item) {
    if (!result) {
        return item;
    }

    return result + ' ' + item;
}, false);

console.log(ex8);

let ex9 = [
    {
        name: 'Angelina Jolie',
        age: 80,
    },
    {
        name: 'Eric Jones',
        age: 2,
    },
    {
        name: 'Paris Hilton',
        age: 5,
    },
    {
        name: 'Kayne West',
        age: 16,
    },
    {
        name: 'Bob Ziroll',
        age: 100,
    },
].reduce(function(result, item) {
    return result + item.age;
}, 0);

console.log(ex9);
